use clap::{arg, value_parser, ArgMatches, Command};
use keyfork_derive_util::{request::*, DerivationPath};

pub fn get_args() -> ArgMatches {
    Command::new("keyfork-seed")
        .arg(
            arg!(--path <PATH>)
                .required(true)
                .help("string value of a DerivationPath")
                .value_parser(value_parser!(DerivationPath)),
        )
        .arg(
            arg!(--algorithm <ALGO>)
                .required(true)
                .help("string value of a DerivationAlgorithm")
                .value_parser(value_parser!(DerivationAlgorithm)),
        )
        .get_matches()
}
