use keyfork_frame::*;
use crate::Result;
use std::os::unix::net::UnixStream;
use keyfork_derive_util::request::*;

#[derive(Debug)]
pub struct Client {
    socket: UnixStream,
}

impl Client {
    pub fn new(socket: UnixStream) -> Self {
        Self { socket }
    }

    pub fn discover_socket() -> Result<Self> {
        super::socket::get_socket().map(|socket| Self { socket })
    }

    pub fn request(&mut self, req: &DerivationRequest) -> Result<DerivationResponse> {
        try_encode_to(&bincode::serialize(&req)?, &mut self.socket)?;
        let resp = try_decode_from(&mut self.socket)?;
        bincode::deserialize(&resp).map_err(From::from)
    }
}
