use keyfork_derive_util::{request::{DerivationRequest, DerivationAlgorithm}, DerivationPath};

#[cfg(test)]
mod tests;

use keyfork_seed::*;

fn main() -> Result<()> {
    let args = cli::get_args();
    let mut client = Client::discover_socket()?;
    let path = args.get_one::<DerivationPath>("path").expect("required");
    let algo = args
        .get_one::<DerivationAlgorithm>("algorithm")
        .expect("required");
    let request = DerivationRequest::new(algo.clone(), path.clone());
    let response = client.request(&request)?;
    dbg!(&response);
    Ok(())
}
